"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.jsonStringLength = exports.numberEqual = exports.isType = exports.isObject = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _textEncoding = require("text-encoding");

var isObject = exports.isObject = function isObject(value) {
  return (typeof value === "undefined" ? "undefined" : _typeof(value)) === "object" && !Array.isArray(value) && value !== null;
};

var isType = exports.isType = {
  "null": function _null(value) {
    return value === null;
  },
  "boolean": function boolean(value) {
    return typeof value === "boolean";
  },
  "object": isObject,
  "array": function array(value) {
    return Array.isArray(value);
  },
  "number": function number(value) {
    return typeof value === "number";
  },
  "string": function string(value) {
    return typeof value === "string";
  }
};

var numberEqual = exports.numberEqual = function numberEqual(a, b) {
  return Math.abs(a - b) < Number.EPSILON;
};

var jsonStringLength = exports.jsonStringLength = function jsonStringLength(string) {
  return new _textEncoding.TextEncoder("utf-8").encode(string).length;
};