"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interpret = exports.compile = exports.type = undefined;

var _bluebird = require("bluebird");

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _jsonValidationCore = require("../../json-validation-core");

var Core = _interopRequireWildcard(_jsonValidationCore);

var _jsonValidation = require("../../json-validation");

var JsonValidation = _interopRequireWildcard(_jsonValidation);

var _validationResult = require("../../validation-result");

var ValidationResult = _interopRequireWildcard(_validationResult);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var type = exports.type = "object";

var compile = exports.compile = function () {
  var _ref = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(doc, ast) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return JsonValidation.entries(doc).map(function () {
              var _ref2 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref3) {
                var _ref4 = _slicedToArray(_ref3, 2),
                    propertyPattern = _ref4[0],
                    propertyDoc = _ref4[1];

                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return Core.compile(propertyDoc, ast);

                      case 2:
                        return _context.abrupt("return", [new RegExp(propertyPattern), propertyDoc.url]);

                      case 3:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, undefined);
              }));

              return function (_x3) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 2:
            return _context2.abrupt("return", _context2.sent);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function compile(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var interpret = exports.interpret = function interpret(patternProperties, value, ast) {
  return patternProperties.every(function (_ref5) {
    var _ref6 = _slicedToArray(_ref5, 2),
        pattern = _ref6[0],
        property = _ref6[1];

    return Object.keys(value).filter(function (propertyName) {
      return pattern.test(propertyName);
    }).every(function (propertyName) {
      var result = Core.interpret(ast, property)(value[propertyName]);
      return ValidationResult.isValid(result);
    });
  });
};